package Server_Client.NetWorkGame;

import UI.GameState.*;
import UI.LogIn.Game.GameFrame;
import UI.Registration.InitialFrame;
import UI.Registration.InitialPanel;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Scanner;

public class Client1 {
    private Socket socket = null;
    private String host;
    private int port;
    private int myX, myY, myRotate;
    private ArrayList<BulletState> myBullets;
    private String serverAns;
    private String[] enemyComponents;
    private int numOfEnemies;
    private String wallMap;
    private WallState wallState;
    private  OutputStream out;
    private InputStream in;

    public Client1(String address , int port) {
        this.host = address;
        this.port = port;
        numOfEnemies = 0;
        wallState = new WallState(GameFrame.GAME_WIDTH , GameFrame.GAME_HEIGHT);
    }

    public void run0() throws IOException {

        socket = new Socket(host,port);
        out = socket.getOutputStream();
        in = socket.getInputStream();
    }

    public void run1wall() throws IOException {
        out.write(InitialPanel.userName.getText().getBytes());

        byte[] buffer = new byte[2048];
        int read = in.read(buffer);
        wallMap  = new String(buffer,0,read);
    }

    public void runToUpdateTank(TankState tankState) throws IOException {
        try {
            boolean running = true;
            //      do {
            String clientText = "";
            clientText = myTankComponents();
            running = !clientText.equalsIgnoreCase("over");
            out.write(clientText.getBytes());

            byte[] buffer1 = new byte[2048];
            int read1 = in.read(buffer1);
            serverAns = new String(buffer1, 0, read1);
            System.out.println("- From Server : " + serverAns);
            //     }while(running);
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

        public void close() throws IOException {
        out.write("over".getBytes());
        System.out.println("Client disconnected.");
            socket.close();
    }

    private int getNumOfEnemies(){
        String[] s = serverAns.split(" ");
        System.out.println(serverAns);
        System.out.println(s.length+"ength");
        numOfEnemies = (s.length)/6;
        System.out.println(numOfEnemies+"num of enemies");
        return numOfEnemies;
    }

    public ArrayList<EnemyTank> createEnemyTanks(){
        ArrayList<EnemyTank> enemyTanks = new ArrayList<>();
        for (int i = 0 ; i < getNumOfEnemies() ; i ++){
            EnemyTank enemyTank = new EnemyTank(getWallState());
            enemyTanks.add(enemyTank);
        }
        if (enemyTanks == null)
            enemyTanks = new ArrayList<>();
        return enemyTanks;
    }

    public void updateEnemyComponents(ArrayList<EnemyTank> enemyTanks){
        int j = 0;
        enemyComponents = serverAns.split(" ");
        for (int i = 0 ; i < getNumOfEnemies() ; i++){
            enemyTanks.get(i).locX = Integer.parseInt(enemyComponents[j]);j++;
            enemyTanks.get(i).locY = Integer.parseInt(enemyComponents[j]);j++;
            enemyTanks.get(i).rotate = Integer.parseInt(enemyComponents[j]);j++;
            for (BulletState bullet : enemyTanks.get(i).getBullets()){
                bullet.locX = Integer.parseInt(enemyComponents[j]);j++;
                bullet.locY = Integer.parseInt(enemyComponents[j]);j++;
            }
        }
    }


    public void updateMyTank (TankState myTank) throws IOException {
        myX = myTank.locX;
        myY = myTank.locY;
        myRotate = myTank.rotate;
        myBullets = myTank.getBullets();
    }

    private String myTankComponents(){
        String tankComponent , bulletComponent = "";
        tankComponent = myX +" "+ myY +" " + myRotate ;
        if (myBullets == null)
            return tankComponent;
        for (BulletState bullet : myBullets){
            bulletComponent +=" " + bullet.locX + " " + bullet.locY ;
        }
        return tankComponent+bulletComponent;
    }

    public WallState getWallState() {
        wallState.setSource(wallMap);
        return wallState;
    }
}
