package UI.LogIn;

import Server_Client.NetWorkGame.Client1;
import UI.LogIn.Game.GameFrame;
import UI.LogIn.Game.GameLoop;
import UI.LogIn.Game.ThreadPool;
import UI.LogIn.NetWorkGame.NWGFrame;
import UI.LogIn.NetWorkGame.NWGLoop;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.*;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.IOException;
import java.net.InetAddress;
import java.net.UnknownHostException;

public class MainPanel extends JPanel {

    private Image image;

    public MainPanel() throws IOException {
        image = ImageIO.read(new File("C:\\Users\\Lenovo\\IdeaProjects\\JTankTrouble\\pics\\index.png"));
        initComponents();
    }


    private void initComponents(){
        setLayout(new BorderLayout());
        ImageIcon imageIcon = new ImageIcon(image);
        JButton label = new JButton();
        label.setIcon(imageIcon);
        add(label , BorderLayout.CENTER);
        JButton multiPlaysBtn = new JButton("MultiPlayers");
        multiPlaysBtn.setPreferredSize(new Dimension(200 ,250));
        JButton settingBtn = new JButton("Setting");
        JButton singlePlayBtn = new JButton("SinglePlayer");
        JButton leaveAccountBtn = new JButton("Leave current account");
        JPanel jPanel = new JPanel(new GridLayout(1 ,4));
        jPanel.add(singlePlayBtn);
        jPanel.add(multiPlaysBtn);
        jPanel.add(settingBtn);
        jPanel.add(leaveAccountBtn);
        add(jPanel , BorderLayout.SOUTH);
        singlePlayBtn.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                run();

            }
        });

        multiPlaysBtn.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                Client1 client1 = null;
                try {
                    client1 = new Client1(InetAddress.getLocalHost().getHostName(),5001);
                    run2(client1);
                } catch (UnknownHostException ex) {
                    ex.printStackTrace();
                }
            }
        });

        settingBtn.addMouseListener(new MouseAdapter() {
            @Override
            public void mouseClicked(MouseEvent e) {
                super.mouseClicked(e);
                removeAll();
                try {
                    add(setSettingPanel());
                } catch (IOException ex) {
                    ex.printStackTrace();
                }
                MainPanel.this.revalidate();
                MainPanel.this.repaint();
            }
        });
    }

    private JPanel setSettingPanel() throws IOException {
        SettingPanel settingPanel = new SettingPanel();
        settingPanel.revalidate();
        settingPanel.revalidate();
        return settingPanel;
    }

    private void run() {
        // Initialize the global thread-pool
        ThreadPool.init();
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                GameFrame frame = new GameFrame("Trouble Tank");
                frame.setLocationRelativeTo(null); // put frame at center of screen
                frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
                frame.setVisible(true);
                frame.initBufferStrategy();
                // Create and execute the game-loop
                GameLoop game = new GameLoop(frame);
                game.init();
                ThreadPool.execute(game);
                // and the game starts ...
            }
        });
    }

    private void run2(Client1 client1) {
        // Initialize the global thread-pool
        ThreadPool.init();
        EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                try {
                    client1.run0();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                NWGFrame frame = new NWGFrame("Trouble Tank");
                frame.setLocationRelativeTo(null); // put frame at center of screen
                frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
                frame.setVisible(true);
                frame.initBufferStrategy();
                // Create and execute the game-loop
                NWGLoop game = new NWGLoop(frame , client1);
                try {
                    game.init();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                System.out.println("222222 after init");
                ThreadPool.execute(game);
                System.out.println("after thearsd");
                // and the game starts ...
            }
        });
    }
}
