package UI.LogIn.NetWorkGame;

import Server_Client.NetWorkGame.Client1;
import UI.GameState.EnemyTank;
import UI.GameState.MyTank;
import UI.LogIn.Game.GameFrame;

import java.io.IOException;
import java.util.ArrayList;

/*** In The Name of Allah ***/

    /**
     * A very simple structure for the main game loop.
     * THIS IS NOT PERFECT, but works for most situations.
     * Note that to make this work, none of the 2 methods
     * in the while loop (update() and render()) should be
     * long running! Both must execute very quickly, without
     * any waiting and blocking!
     *
     * Detailed discussion on different game loop design
     * patterns is available in the following link:
     *    http://gameprogrammingpatterns.com/game-loop.html
     *
     * @author Seyede zahra seyed fatehi
     */
    public class NWGLoop implements Runnable {

        /**
         * Frame Per Second.
         * Higher is better, but any value above 24 is fine.
         */
        public static final int FPS = 30;

        private NWGFrame canvas;
        private MyTank myTank;
        private ArrayList<EnemyTank> enemyTanks;
        private Client1 client1;
        public NWGLoop(NWGFrame frame , Client1 client1) {
            canvas = frame;
            this.client1 = client1;
        }
        public static long startTime;

        /**
         * This must be called before the game loop starts.
         */
        public void init() throws IOException {
            // Perform all initializations ...
            myTank = new MyTank(client1.getWallState());
            client1.run1wall();
            client1.runToUpdateTank(myTank);
            enemyTanks = client1.createEnemyTanks();
            canvas.addKeyListener(myTank.getMyListener());
            canvas.addMouseListener(myTank.getMouseListener());
            canvas.addMouseMotionListener(myTank.getMouseMotionListener());
            startTime = 0;
        }

        @Override
        public void run() {
            boolean gameOver = false;
            while (!gameOver) {
                try {
                    long start = System.currentTimeMillis();
                    myTank.update();
                    client1.runToUpdateTank(myTank);
                    client1.updateEnemyComponents(enemyTanks);
                    client1.updateMyTank(myTank);
                    canvas.render(myTank , enemyTanks , client1.getWallState());
                    long delay = (1000 / FPS) - (System.currentTimeMillis() - start);
                    if (delay > 0)
                        Thread.sleep(delay);
                } catch (InterruptedException | IOException ex) {
                }
            }
            try {
                client1.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

